Object.defineProperty(exports, "__esModule", { value: true });
const strip = require("strip-comments");
const getOptionsArray_1 = require("./getOptionsArray");
const envStore_1 = require("./envStore");
function default_1(source, map) {
    if (!source) {
        return source;
    }
    this.cacheable && this.cacheable();
    const optionsArray = (0, getOptionsArray_1.default)(this);
    try {
        const cleanVersion = source
            .substring(source.indexOf('/* start */'), source.indexOf('/* end */'))
            .replace('/* start */', '')
            .trim();
        // strip comments, wrap lines into single line and remove spaces
        const stripComment = strip(cleanVersion).replace(/\n/g, ' ').replace(/(?<!\n\s*)[ ]+/g, '');
        const startregex = /(?:^|\W)\(0,_envalid(?:.(str|num|json))\)(\(\{?)/g;
        const endregex = /\}?(\)\,|\}\))/g;
        const defaultRegex = /({default:.*?(\}\,))/g;
        const devDefaultRegex = /({devDefault:.*?(\}\,))/g;
        const emptyRegex = /{},/g;
        const filteredData = stripComment
            .replace(startregex, ':{')
            .replace(endregex, '},')
            .replace(defaultRegex, '{required: false},')
            .replace(devDefaultRegex, '{devRequired: false},')
            .replace(emptyRegex, '{required: true},');
        if (filteredData) {
            eval('var filteredObj=' + filteredData);
            // @ts-ignore
            envStore_1.default.addFunction([Object.assign({}, filteredObj)]);
        }
    }
    catch (err) {
        console.error(err);
    }
    if (this.resource.includes('public-config')) {
        try {
            const searchString = 'const publicEnv=[';
            const stripComment = strip(source).replace(/\n/g, ' ').replace(/(?<!\n\s*)[ ]+/g, '').replace('constpublicEnv=[', ' ' + searchString);
            const publicEnvString = stripComment
                .substring(stripComment.indexOf(searchString), stripComment.indexOf(']'))
                .replace(searchString, '')
                .trim();
            eval('var currentKeys=[' + publicEnvString + ']');
            // @ts-ignore
            envStore_1.default.currentKeys = currentKeys;
        }
        catch (err) {
            console.error(err);
        }
    }
    return source;
}
exports.default = default_1;
;
//# sourceMappingURL=loader.js.map